#include "header.h"

CBigNumber::CBigNumber(): high(0), low(0) {}
    CBigNumber::CBigNumber(const uint64_t high, const uint64_t low): high(high), low(low) {}
    void CBigNumber::setter(const uint64_t high, const uint64_t low) {this->high=high, this->low=low;}
    void CBigNumber::setter(const uint64_t low) {this->high=0, this->low=low;}
    void CBigNumber::printpairdec(){std::cout<<high<<' '<<low;}
    CBigNumber::CBigNumber(const uint64_t low): high(0), low(low) {}
    uint64_t* CBigNumber::getter(){uint64_t* values=new uint64_t[2];values[0]=high;values[1]=low;return values;}
    CBigNumber CBigNumber::operator+(const CBigNumber& other)const{
        CBigNumber result;
        result.low=low+other.low;
        result.high=high+other.high+(result.low<low?1:0);
        return result;
    }
    CBigNumber CBigNumber::operator-(const CBigNumber& other)const{
        CBigNumber result;
        result.low=low-other.low;
        result.high=high-other.high-(result.low>low?1:0);
        return result;
    }
    /*std::string*/ void CBigNumber::printhex(char fill){//std::ostringstream out;
        if(high){std::cout<<std::setfill('0')<<std::setw(fill)<<std::hex<<high;std::cout<<std::setw(16);}
        std::cout<<std::setfill('0')<<std::hex<<low;
        //return out.str();
    }
